(function()
{
   var $ = document,
       display = function(displayProp){ return displayProp === "block" ? "none" : "block"; };
   
   /* Draggable window */
   var windowHeader = $.getElementById("windowHeader");
   window.draggable(windowHeader.parentNode, windowHeader);
         
   windowHeader.parentNode.whenDragStarts(function(event){ return event.mouseEvent.button === 0; });
   var content;
   $.getElementById("minObjectWindow").onclick = function()
   {
      content = $.getElementById("objectWindowContent");
      content.style.display = window.getComputedStyle(content).getPropertyValue("display");
      
      content.style.display = display(content.style.display);
   };

   /* Colorpicker */
   var colorControl = $.getElementById("materialColor");
   var colorPickerButton = $.getElementById("colorPicker");
   colorPickerButton.addEventListener("click", function(){ colorControl.color.showPicker(); }, false);
   
   
   /* Standard objects */
   window.mesh.coordinateSystem.create();
   
   /* Options */
   $.getElementById("optionHead").onclick = function()
   {
      content = $.getElementById("optionsContent");
      content.style.display = window.getComputedStyle(content).getPropertyValue("display");
      
      content.style.display = display(content.style.display);
   };
   // Show grid.
   var grid = window.mesh.grid.create();
   $.getElementById("gridCheckbox").onchange = function()
   {      
      if(this.checked)
      {
         window.scene.add(grid);
      }
      else
      {
         window.scene.remove(grid);  
      }
   };
   
   // Lightobject.
   var lightObj = {
      xCoord: -300,
      yCoord: 200,
      zCoord: 0,
      lightColor: 0xffffff,
      showShadowCamera: true
   };
   
   window.mesh.lightObject(lightObj);
   window.render();
}());


//   var spinCtrl = new SpinControl();
//   spinCtrl.GetAccelerationCollection().Add(new SpinControlAcceleration(1, 500));
//   spinCtrl.GetAccelerationCollection().Add(new SpinControlAcceleration(5, 1750));
//   document.getElementById("t").appendChild(spinCtrl.GetContainer());
//   spinCtrl.StartListening();